<?php

/**
 * UserIdentity represents the data needed to identity a user.
 * It contains the authentication method that checks if the provided
 * data can identity the user.
 */
class UserIdentity extends CUserIdentity
{	
	/**
	 * 
	 */
	private $_id;
	
	/**
	 * Authenticates a user.
	 * @return boolean whether authentication succeeds or not.
	 */
	public function authenticate()
	{
		$record = User::model()->findByAttributes(array(
			'username' => $this->username,
		));
		if($record === null)
		{
			$this->errorCode = self::ERROR_USERNAME_INVALID;
		}else if($record->password !== User::encryptPassword($this->password))
		{
			$this->errorCode = self::ERROR_PASSWORD_INVALID;
		}else{
			$record->saveAttributes(array(
				'last_login_time' => time(),
				'last_login_ip'   => Yii::app()->request->getUserHostAddress(),
			));
			
			$this->_id       = $record->id;
			$this->errorCode = self::ERROR_NONE;
		}
		return !$this->errorCode;
	}

	/**
	 * 
	 */
	public function getId()
	{
		return $this->_id;
	}
}