CREATE TABLE IF NOT EXISTS `auth_assignment` (
  `itemname` varchar(64) NOT NULL,
  `userid` varchar(64) NOT NULL,
  `bizrule` text,
  `data` text,
  PRIMARY KEY (`itemname`,`userid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;





CREATE TABLE IF NOT EXISTS `auth_item` (
  `name` varchar(64) NOT NULL,
  `type` int(11) unsigned NOT NULL,
  `description` text,
  `bizrule` text,
  `data` text,
  PRIMARY KEY (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


INSERT INTO `auth_item` (`name`, `type`, `description`, `bizrule`, `data`) VALUES
('authenticated', 2, 'authenticated user', 'return !Yii::app()->user->isGuest;', 'N;'),
('guest', 2, 'guest user', 'return Yii::app()->user->isGuest;', 'N;');



CREATE TABLE IF NOT EXISTS `auth_item_child` (
  `parent` varchar(64) NOT NULL,
  `child` varchar(64) NOT NULL,
  PRIMARY KEY (`parent`,`child`),
  KEY `FK_auth_item_child_auth_item_child` (`child`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;





CREATE TABLE IF NOT EXISTS `block` (
  `id` int(100) unsigned NOT NULL AUTO_INCREMENT,
  `location` varchar(100) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `location` (`location`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;


INSERT INTO `block` (`id`, `location`) VALUES
(1, 'sidebar.left'),
(2, 'sidebar.right');



CREATE TABLE IF NOT EXISTS `block_item` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `block_id` int(10) unsigned NOT NULL,
  `name` varchar(100) NOT NULL,
  `position` int(10) NOT NULL,
  `content` text NOT NULL,
  `static` tinyint(1) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_block_item_block` (`block_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;


INSERT INTO `block_item` (`id`, `block_id`, `name`, `position`, `content`, `static`) VALUES
(1, 2, 'Quick Login', 2, 'return Yii::app()->controller->widget(''application.components.widgets.QuickLogin'',array(), true);', 0),
(2, 2, 'test block item', 0, 'content here', 1);



CREATE TABLE IF NOT EXISTS `friendship` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user1_id` int(10) unsigned NOT NULL,
  `user2_id` int(10) unsigned NOT NULL,
  `create_time` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `user1_id` (`user1_id`,`user2_id`),
  KEY `FK_friendship_user2` (`user2_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;





CREATE TABLE IF NOT EXISTS `friend_request` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user1_id` int(10) unsigned NOT NULL,
  `user2_id` int(10) unsigned NOT NULL,
  `create_time` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `user1_id` (`user1_id`,`user2_id`),
  KEY `FK_friend_request_user12` (`user2_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;





CREATE TABLE IF NOT EXISTS `private_message_in` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `to_user_id` int(10) unsigned NOT NULL,
  `from_user_id` int(10) unsigned NOT NULL,
  `subject` varchar(255) NOT NULL,
  `body` text NOT NULL,
  `create_time` int(10) unsigned NOT NULL,
  `status` tinyint(1) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_private_message_in_to_user` (`to_user_id`),
  KEY `FK_private_message_in_from_user` (`from_user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;





CREATE TABLE IF NOT EXISTS `private_message_out` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `to_user_id` int(10) unsigned NOT NULL,
  `from_user_id` int(10) unsigned NOT NULL,
  `subject` varchar(255) NOT NULL,
  `body` text NOT NULL,
  `create_time` int(10) unsigned NOT NULL,
  `status` tinyint(1) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_private_message_in_to_user` (`to_user_id`),
  KEY `FK_private_message_in_from_user` (`from_user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;





CREATE TABLE IF NOT EXISTS `user` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `username` varchar(32) NOT NULL,
  `primary_email_id` int(10) unsigned NOT NULL,
  `password` varchar(32) NOT NULL,
  `status` tinyint(1) unsigned NOT NULL,
  `create_time` int(10) unsigned NOT NULL,
  `last_update_time` int(10) unsigned DEFAULT NULL,
  `last_login_time` int(10) unsigned DEFAULT NULL,
  `last_active_time` int(10) unsigned DEFAULT NULL,
  `create_ip` varchar(39) NOT NULL,
  `last_login_ip` varchar(39) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `username` (`username`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;





CREATE TABLE IF NOT EXISTS `user_email` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL,
  `email` varchar(50) NOT NULL,
  `confirmed` tinyint(1) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `email` (`email`),
  KEY `FK_user_email_user` (`user_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;





CREATE TABLE IF NOT EXISTS `user_email_confirmation` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL,
  `email_id` int(10) unsigned NOT NULL,
  `code` varchar(32) NOT NULL,
  `create_time` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `user_id` (`user_id`,`email_id`,`code`),
  KEY `FK_user_email_confirmation_user` (`user_id`),
  KEY `FK_user_email_confirmation_user_email` (`email_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;





CREATE TABLE IF NOT EXISTS `user_password_reset` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL,
  `code` varchar(32) NOT NULL,
  `create_time` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `user_id` (`user_id`,`code`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;





CREATE TABLE IF NOT EXISTS `user_profile` (
  `user_id` int(10) unsigned NOT NULL,
  `first_name` varchar(50) NOT NULL,
  `last_name` varchar(50) NOT NULL,
  `birth_date` date NOT NULL,
  `gender` tinyint(1) unsigned NOT NULL,
  PRIMARY KEY (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;




ALTER TABLE `auth_assignment`
  ADD CONSTRAINT `FK_auth_assignment_auth_item` FOREIGN KEY (`itemname`) REFERENCES `auth_item` (`name`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `auth_item_child`
  ADD CONSTRAINT `FK_auth_item_child_auth_item_child` FOREIGN KEY (`child`) REFERENCES `auth_item` (`name`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `FK_auth_item_child_auth_item_parent` FOREIGN KEY (`parent`) REFERENCES `auth_item` (`name`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `block_item`
  ADD CONSTRAINT `FK_block_item_block` FOREIGN KEY (`block_id`) REFERENCES `block` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `friendship`
  ADD CONSTRAINT `FK_friendship_user1` FOREIGN KEY (`user1_id`) REFERENCES `user` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `FK_friendship_user2` FOREIGN KEY (`user2_id`) REFERENCES `user` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `friend_request`
  ADD CONSTRAINT `FK_friend_request_user2` FOREIGN KEY (`user2_id`) REFERENCES `user` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `FK_friend_request_user1` FOREIGN KEY (`user1_id`) REFERENCES `user` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `private_message_in`
  ADD CONSTRAINT `FK_private_message_in_from_user` FOREIGN KEY (`from_user_id`) REFERENCES `user` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `FK_private_message_in_to_user` FOREIGN KEY (`to_user_id`) REFERENCES `user` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `private_message_out`
  ADD CONSTRAINT `FK_private_message_out_from_user` FOREIGN KEY (`from_user_id`) REFERENCES `user` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `FK_private_message_out_to_user` FOREIGN KEY (`to_user_id`) REFERENCES `user` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `user_email`
  ADD CONSTRAINT `FK_user_email_user` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `user_email_confirmation`
  ADD CONSTRAINT `FK_user_email_confirmation_user` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `FK_user_email_confirmation_user_email` FOREIGN KEY (`email_id`) REFERENCES `user_email` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `user_password_reset`
  ADD CONSTRAINT `FK_user_password_reset_user` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `user_profile`
  ADD CONSTRAINT `FK_user_profile_user` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
